#if !defined(WmcloseShellP_h)
#define WmcloseShellP_h

#include <X11/ShellP.h>
#include "WmcloseShell.h"

typedef struct {
  XtCallbackList wmclosecallback ;
  XtCallbackList destroycallback ;
} WmcloseShellPart ;

/* դ뤤󤹤󤹡 */
typedef struct _SubwindowShellRec {
  CorePart		core ;
  CompositePart		composite ;
  ShellPart 		shell ;
  WMShellPart		wm ;
  VendorShellPart	vendor ;
  TransientShellPart	transient ;	
  WmcloseShellPart	wmclose ;
} WmcloseShellRec ;

/* New fields for the My widget class record */
typedef struct {
  int dummy ;
} WmcloseShellClassPart ;

/* դ뤯餹 */
typedef struct _SubshellClassRec {
  CoreClassPart			core_class ;
  CompositeClassPart		composite_class ;
  ShellClassPart		shell_class ;
  WMShellClassPart   		wm_shell_class ;
  VendorShellClassPart 		vendor_shell_class ;
  TransientShellClassPart 	transient_shell_class ;
  WmcloseShellClassPart		wmclose_shell_class ;
} WmcloseShellClassRec ;

/* 餹ݤ󤿡 */
extern WmcloseShellClassRec	wmcloseShellClassRec ;

#endif
