#ifndef attrs_h
#define attrs_h

#define CASpotLocation		((unsigned long)1L << 1)
#define CAFocusWindow		((unsigned long)1L << 2)
#define CAClientArea		((unsigned long)1L << 3)
#define CAStatusArea		((unsigned long)1L << 4)
#define CAColormap		((unsigned long)1L << 5)
#define CAColor			((unsigned long)1L << 6)
#define CABackgroundPixmap	((unsigned long)1L << 7)
#define CALineSpacing		((unsigned long)1L << 8)
#define CAFonts			((unsigned long)1L << 9)
#define CACursor		((unsigned long)1L <<10)

struct ConvAttrs {
  Position	spot_x, spot_y ;
  Window	focus_window ;
  XRectangle	client_area ;
  XRectangle	status_area ;
  Colormap	colormap ;
  Pixel	foreground, background ;
  XFontStruct	**fontset ;
  Cardinal	num_fonts ;
  Dimension	linespacing ;
  /* ̵뤹롣ͳϰ٤ˤȼݤ顣*/
#if 0
  Pixmap	background_pixmap ;
  Cursor	cursor ;
#endif
} ;

/*
 * Widget ֤ǥåѤ빽¤Ρ
 *-------
 * ǸåϡXtSetValue ڤ XtGetValue ˤäƼϤ
 * 롣
 */
struct ConvAttrsMesg {
  unsigned long		mask ;
  struct ConvAttrs	value ;
} ;

#endif
