/*
 * Kinput Protocol ˤĤơ
 */
#ifndef protocol_h
#define protocol_h

/* ѴФΥץե뤬ץѥƥ̾ */
#define CONVERSION_PROFILE	"_CONVERSION_PROFILE"

/* ѴФѴ°ΥץѥƥΥ */
#define CONVERSION_ATTRIBUTE_TYPE	"_CONVERSION_ATTRIBUTE_TYPE"

/* ץȥС̾ */
#define PROTOCOL_VERSION	"PROTOCOL-2.0"

#define MAKE_CONVERSION_ATTRIBUTE( code, len ) \
( ( unsigned long )( ( ( unsigned long )( code ) ) << 16 ) + ( len ) )

enum {
  CONVERSION_PROFILE_PROTOCOL_VERSION = 1,
  CONVERSION_PROFILE_SUPPORTED_STYLES,
  CONVERSION_PROFILE_SUPPORTED_EXTENSIONS,
  CONVERSION_PROFILE_EXTENSION_DATA,
} ;

/* 饤Ȥ°ѹΤ줿˲ѹ줿Τ *
 * ڤΤѤ */
enum {
  CONVERSION_ATTRIBUTE_NASHI = 0,
  CONVERSION_ATTRIBUTE_HA_INDIRECT,
  CONVERSION_ATTRIBUTE_FOCUS_WINDOW,
  CONVERSION_ATTRIBUTE_BASHO_SHITEI,
  CONVERSION_ATTRIBUTE_CLIENT_AREA,
  CONVERSION_ATTRIBUTE_STATUS_AREA,
  CONVERSION_ATTRIBUTE_COLORMAP,
  CONVERSION_ATTRIBUTE_COLOR,
  CONVERSION_ATTRIBUTE_BACKGROUND_PIXMAP,
  CONVERSION_ATTRIBUTE_LINE_SPACING,
  CONVERSION_ATTRIBUTE_FONT_ATOMS,
  CONVERSION_ATTRIBUTE_CURSOR,
} ;

/*
 * 䥤٥Ȥץȥγĥ°
 */
#define CONVERSION_ATTRIBUTE_NYUURYOKU_HOUSHIKI		(128)
#define CONVERSION_ATTRIBUTE_EVENT_NO_TOBASHIKATA	(129)
#define CONVERSION_ATTRIBUTE_KAKUCHOU			(255)

/*
 * ä˲ǤΤμˤĤơ
 */
#define CONVERSION_NYUURYOKU_HOUSHIKI_SEPARATEMADO	(1L)
#define CONVERSION_NYUURYOKU_HOUSHIKI_OFFTHESPOT	(2L)
#define CONVERSION_NYUURYOKU_HOUSHIKI_OVERTHESPOT	(4L)

/*
 * 뤬褿˥٥ȤɤΤ褦ФΤꤹΤѡ
 */
#define CONVERSION_EVENT_TOBASHI_NASHI			(0L)
#define CONVERSION_EVENT_TOBASHI_ZENBU_SKKINPUT_HE	(1L)
#define CONVERSION_EVENT_TOBASHI_FOCUS_NO_HOUHE		(2L)

/*
 * ¾
 */
#define ULONG_UPPER16BIT(data)	\
  (((( unsigned long )( data )) >> 16 ) & 0xffffL )
#define ULONG_LOWER16BIT(data)	\
  ((( unsigned long )( data )) & 0xffffL )
#define USHORT_UPPER16BIT(data) \
  (( unsigned short )(((( unsigned long )( data )) >> 16 ) & 0xffffL ))
#define USHORT_LOWER16BIT(data) \
  (( unsigned short )(((( unsigned long )( data )) & 0xffffL )))

#define LENGTH_OF_ATTRIBUTE(data)	\
  ( ULONG_LOWER16BIT( ( data ) ) )
#define CODE_OF_ATTRIBUTE(data)		\
  ( ULONG_UPPER16BIT( ( data ) ) )
#endif
