/*
 * skkinput ɽؿ
 *-----
 * ϺʬԤʤ
 */
static void skkinput_FullDrawWindow
( Display *disp, Window win, 
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  struct SKKInputNode *node, char *text, 
  int start_pos, int x, int y, int end_x, int end_y,
  int roman_width, int kanji_width, int font_height, int font_ascent )
{
  int pos, chara, kana_flag, kanji_check, cursor_flag ;
  int cx, cy ;

  pos         = start_pos ;
  kana_flag   = False ;
  cursor_flag = False ;

  chara = cx = cy = 0 ;

  while( *text != '\0' ){
    /* ɤȽԤ*/
    kanji_check = 0x80 & *text ;
    /* ɽʤΤɤȽꤹ롣*/
    if( pos == node->cur_pos ){
      if( node->cur_exist ){
	skkinputDrawCursor
	  ( disp, win,
	    roman_ngc, kanji_ngc, roman_rgc, kanji_rgc,
	    x, y,
	    roman_width, kanji_width,
	    font_height, kanji_check ) ;
	cursor_flag = True ;
      }
      cx = x ;
      cy = y ;
    }
    /* ɤΰХܤʤΤǤ礦 */
    if( kanji_check && kana_flag == False ){
      kana_flag = True ;
      chara = ( unsigned char )*text ;
      /* ̤αüޤ褷ΤɤȽǤ롣*/
      if( ( x + kanji_width ) >= end_x ){
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc, x, y, '\\', False ) ;
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc, 
	    x + roman_width, y, '\\', False ) ;
	x = 0 ;
	y += font_height ;
	/* ̤βޤǽڤäΤɤȽǤ롣*/
	if( y >= end_y )
	  goto exit_loop ;
      }
    } else {
      /* ɤХܤʤΤǤ礦 */
      if( kana_flag ){
	chara = ( chara << 8 ) | ( ( unsigned char )*text ) ;
	/* ξ˥ɽƤΤǤ */
	if( cursor_flag ){
	  skkwin_jputchar
	    ( disp, win, roman_rgc, kanji_rgc, x, y, chara, False ) ;
	  cursor_flag = False ;
	} else {
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, chara, True ) ;
	}
	x += kanji_width ;
	kana_flag = False ;
      } else {
	/* ɤäνǤ*/
	if( ( x + roman_width ) >= end_x ){
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, '\\', False ) ;
	  x =  0 ;
	  y += font_height ;
	  /* ̤βޤǽڤäΤɤȽǤ롣*/
	  if( y >= end_y )
	    goto exit_loop ;
	}
	/* ΰ֤˥뤬ɽƤΤǤСʸȿž *
	 * 롣*/
	if( cursor_flag ){
	  skkwin_jputchar
	    ( disp, win, roman_rgc, kanji_rgc, x, y, *text, False ) ;
	  cursor_flag = False ;
	} else {
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, *text, True ) ;
	}
	x += roman_width ;
      }
    }
    text ++ ;
    pos ++ ;
  }
  /* Ǹޤǥ뤬ɽƤʤäΤʤ顢ǸιԤ˥ *
   * ɽ롣*/
  if( pos == node->cur_pos && node->cur_exist ){
    /* Ԥɬפꡩ */
    if( ( x + roman_width ) > end_x ){
      skkwin_jputchar
	( disp, win, roman_ngc, kanji_ngc, x, y, '\\', False ) ;
      x  = 0 ;
      y += font_height ;
    }
    skkinputDrawCursor
      ( disp, win, roman_ngc, kanji_ngc, roman_rgc, kanji_rgc,
        x, y, roman_width, kanji_width, font_height, font_ascent,
        False ) ; 
    cx = x ;
    cy = y ;
  }

exit_loop:
  node->prev_cx = cx ; 
  node->prev_cy = cy ;
}

/*
 * skkinput Υ⡼ɥ饤ʬ褹ؿ
 */
static void skkinput_DiffDrawModeLine
( Widget gw, struct SKKInputNode *node, int x, int y, unsigned int width )
{
  SeparateWinWidget w = ( SeparateWinWidget )gw ;
  static char *modelineStrings[] = {
    "SKK:", "", "", "",
  } ;
  static char *modelineStrings2[] = {
    "--", "**",
  } ;
  static char *chatAdapterStrings[] = {
    "(Fundamental",
    "(ChatAdapter",
  } ;
  int modeline = skkinput_GetModelineNumber( node ) ;

  /* ⡼ɥ饤ɽ줿ΤƱǤ뤫ɬפ *
   * ʤ*/
  if( w->separateWin.prev_modeline != modeline ){
    /* ѹоݤȤʤʬõ롣*/
    XFillRectangle
      ( XtDisplay( gw ), XtWindow( gw ), w->separateWin.roman_ngc,
	x + w->separateWin.roman_width * 2,
	y - w->separateWin.font_ascent,
	w->separateWin.kanji_width * 2,
	w->separateWin.font_height ) ;
    /* ⡼ɥ饤ʬ褹롣*/
    skkwin_jputstring
      ( XtDisplay( gw ), XtWindow( gw ),
        w->separateWin.roman_rgc, w->separateWin.kanji_rgc, 
        x + w->separateWin.roman_width * 2, y,
	modelineStrings[ modeline - 1 ],
	w->separateWin.roman_width,
	w->separateWin.kanji_width ) ;
    /* ɽФ롣*/
    w->separateWin.prev_modeline = modeline ;
  }
  if( w->separateWin.prev_jisyo_dirty != w->separateWin.jisyo_dirty ){
    /* ѹоݤȤʤʬõ롣*/
    XFillRectangle
      ( XtDisplay( gw ), XtWindow( gw ), w->separateWin.roman_ngc,
       x + w->separateWin.roman_width * 11,
       y - w->separateWin.font_ascent,
       w->separateWin.roman_width * 2,
       w->separateWin.font_height ) ;
    /* ⡼ɥ饤ʬ褹롣*/
    skkwin_jputstring
      ( XtDisplay( gw ), XtWindow( gw ), 
        w->separateWin.roman_rgc, w->separateWin.kanji_rgc, 
        x + w->separateWin.roman_width * 11, y,
        modelineStrings2[ w->separateWin.jisyo_dirty ],
        w->separateWin.roman_width,
        w->separateWin.kanji_width ) ;
    w->separateWin.prev_jisyo_dirty = w->separateWin.jisyo_dirty ;
  }
  if( w->separateWin.prev_chat_adapter != w->separateWin.chat_adapter ){
    /* ѹоݤȤʤʬõ롣*/
    XFillRectangle
      ( XtDisplay( gw ), XtWindow( gw ),
       w->separateWin.roman_ngc,
       x + w->separateWin.roman_width * 35,
       y - w->separateWin.font_ascent,
       w->separateWin.roman_width * 12,
       w->separateWin.font_height ) ;
    /* ⡼ɥ饤ʬ褹롣*/
    skkwin_jputstring
      ( XtDisplay( gw ), XtWindow( gw ),
        w->separateWin.roman_rgc, w->separateWin.kanji_rgc, 
        x + w->separateWin.roman_width * 35, y,
        chatAdapterStrings[ w->separateWin.chat_adapter ],
        w->separateWin.roman_width, w->separateWin.kanji_width ) ;
    w->separateWin.prev_chat_adapter = w->separateWin.chat_adapter ;
  }
  if( w->separateWin.prev_eggnl != w->separateWin.egg_like_newline ){
    /* ѹоݤȤʤʬõ롣*/
    XFillRectangle
      ( XtDisplay( gw ), XtWindow( gw ),
       w->separateWin.roman_ngc,
       x + w->separateWin.roman_width * 47,
       y - w->separateWin.font_ascent,
       w->separateWin.roman_width * 13,
       w->separateWin.font_height ) ;
    /* ⡼ɥ饤ʬ褹롣*/
    if( w->separateWin.egg_like_newline ){
      skkwin_jputstring
	( XtDisplay( gw ), XtWindow( gw ), 
	  w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	  x + w->separateWin.roman_width * 47, y,
	  " egg-nl)--All",
	  w->separateWin.roman_width, w->separateWin.kanji_width ) ;
    } else {
      skkwin_jputstring
	( XtDisplay( gw ), XtWindow( gw ),
	  w->separateWin.roman_rgc, w->separateWin.kanji_rgc, 
	  x + w->separateWin.roman_width * 47, y,
	  ")--All-------",
	  w->separateWin.roman_width, w->separateWin.kanji_width ) ;
    }
    w->separateWin.prev_eggnl = w->separateWin.egg_like_newline ;
  }
  return ;
}

/*
 * skkinput β̤ʬɽѤɽؿ
 *-----
 * ̾β̤ν(ѹ)ϤδؿˤäƹԤ롣
 */
static void skkinput_DrawScreen( Widget gw )
{
  SeparateWinWidget w = ( SeparateWinWidget )gw ;
  int x, y, cur_line, linenum, maxline, spos, sty, edy ;
  Window root ;
  unsigned int width, height, border, depth ;
  char *sptr, *dptr ;
  struct SKKInputNode *node = w->separateWin.topbuffer, *mNode ;

  /* 뤬¸ߤƤꡣ*/

  /* Window  size 롣*/
  XGetGeometry( XtDisplay( gw ), XtWindow( gw ),
	        &root, &x, &y, &width, &height, &border, &depth ) ;

  /* ɽǽԿ롣*/
  maxline = height / w->separateWin.font_height ;
  /* ߡƥȤϲԤޤɽʤФʤʤΤ򻻽Ф롣*/
  linenum = skkinput_GetLineNum
    ( w, node->textbuffer, width, node->cur_pos, &cur_line ) ;

  /* ⡼ɥ饤 minibuffer ΤɬפǤ뤫롣*/
  maxline = ( maxline < 3 )? 1 : maxline - 2 ;

#ifdef DEBUG_LV1
  fprintf( stderr, "cursor_line = %d\n", cur_line ) ;
#endif
  /* ɽǽԿĶƤν֤ϰϤ *
   * ǰֺǽιԤֹ椬Ǥ⾮ʤ褦ꤹ롣*/
  if( linenum >= maxline && cur_line >= maxline ){
    int startline = cur_line - maxline + 1 ;
    /* ꤵ줿꤫ɽʤФʤʤΤǡΰ֤򻻽Ф롣*/
    spos = skkinput_FindStartLine( w, node->textbuffer, startline,
				   width ) ;
    dptr = node->textbuffer + spos ;
    sptr = w->separateWin.pwrite_string + node->prev_start_pos ;
  }  else {
    spos = 0 ;
    /* ˰ֺǽʸɽǽǤ롣*/
    dptr = node->textbuffer ;
    sptr = w->separateWin.pwrite_string + node->prev_start_pos ;
  }    
  sty = w->separateWin.font_ascent ;
  edy = sty + maxline * w->separateWin.font_height ;
  /* Window  buffer ʸɽ롣*/
  skkinput_DiffDrawWindow( gw, node,
			   dptr, sptr, spos, 0, sty, width, edy ) ;
  strcpy( w->separateWin.pwrite_string, node->textbuffer ) ;
  node->prev_start_pos = spos ;

  /* ⡼ɥ饤ɽ롣ʬɽľбͽǤϤ롣*/
  sty = edy ;
  edy = sty + w->separateWin.font_height ;
  skkinput_DiffDrawModeLine( gw, node, 0, sty, width ) ;
			 
  /* mini-buffer ɽ롣*/
  mNode = w->separateWin.lastbuffer ;

  sty = edy ;
  edy = sty + w->separateWin.font_height ;

  /* for debugging */ 
  if( mNode == node ){
    skkwin_jdiffputstring
      ( gw, 0, sty, width, node->mtextbuffer,
	w->separateWin.pmtextbuffer, w->separateWin.roman_width,
	w->separateWin.kanji_width ) ;
    strcpy( w->separateWin.pmtextbuffer, node->mtextbuffer ) ;
  } else {
    if( mNode->mtextbuffer[ 0 ] != '\0' ){
      skkwin_jdiffputstring
	( gw, 0, sty, width, mNode->mtextbuffer,
	  w->separateWin.pmtextbuffer, w->separateWin.roman_width,
	  w->separateWin.kanji_width ) ;
      strcpy( w->separateWin.pmtextbuffer, mNode->mtextbuffer ) ;
    } else {
      /* Window  buffer ʸɽ롣*/
      skkinput_DiffDrawWindow
	( gw, mNode, mNode->textbuffer, w->separateWin.pmtextbuffer,
	  0, 0, sty, width, edy ) ;
      strcpy( w->separateWin.pmtextbuffer, mNode->textbuffer ) ;
    }
  }
  return ;
}

static int skkinput_FindStartLine
( SeparateWinWidget w, unsigned char *text,
  int startline, unsigned int width )
{
  int x, kana_flag, pos ;
  char *ptr ;

  /* ɽѿν*/
  x = pos = kana_flag = 0 ;
  /* 롼ס*/
  for( ptr = text ; *ptr != '\0' ; ptr ++, pos ++ ){
    /* ɤ򸫤롣*/
    if( 0x80 & *ptr ){
      kana_flag = kana_flag % 2 + 1 ;
    } else {
      kana_flag = 0 ;
    }
    /* ɤν*/
    switch( kana_flag ){
      /* ɤξν*/
    case 0 :
      x += w->separateWin.roman_width ;
      if( x >= width ){
	x = w->separateWin.roman_width ;
	startline -- ;
	if( startline <= 0 )
	  goto exit_loop ;
      }
      break ;
      /* ɤΰХܤν*/
    case 1 :
      x += w->separateWin.kanji_width ;
      if( x >= width ){
	x = w->separateWin.kanji_width ;
	startline -- ;
	if( startline <= 0 )
	  goto exit_loop ;
      }
      break ;
      /* ɤХܤν*/
    case 2 :
      break ;
      /* ʳΥɤʤ̵롣*/
    default :
      break ;
    }
  }
exit_loop:
  return pos ;
}

/*
 * Ϥ줿 skkinput Υ⡼ɥ饤󤬲ǤΤĴ٤ؿ
 */
static int skkinput_GetModelineNumber( struct SKKInputNode *node )
{
  int modeline ;
  /* ̾ϥ⡼ɤʤΡ ǤϤʤΡ */
  if( !node->j_mode ){
    /* ϥ⡼ɤʤΡ Ⱦϥ⡼ɤʤΡ */
    if( node->j_zenkaku ){
      modeline = MODELINE_ZENKAKU ;
    } else {
      modeline = MODELINE_HANKAKU ;
    }
  } else {
    /* Ҳ̾ϥ⡼ɤʤΡ ʿ̾ϥ⡼ɤʤΡ */
    if( node->j_katakana_mode ){
      modeline = MODELINE_KATAKANA ;
    } else {
      modeline = MODELINE_KANA ;
    }
  }
  return modeline ;
}

/*
 * cur_line != NULL ʤСΤä꤬ܤǤ뤫֤
 */
static int skkinput_GetLineNum
( SeparateWinWidget w, unsigned char *text, unsigned int width,
  int cur_pos, int *cur_line )
{
  int num, cur_num, x, y, pos, kana_flag ;
  char *ptr ;

  /* ɽѿν*/
  x = y = pos = kana_flag = cur_num = num = 0 ;
  /* 롼ס*/
  for( ptr = text ; *ptr != '\0' ; ptr ++, pos ++ ){
    /* ɤ򸫤롣*/
    if( 0x80 & *ptr ){
      kana_flag = kana_flag % 2 + 1 ;
    } else {
      kana_flag = 0 ;
    }
    /* ɤν*/
    switch( kana_flag ){
      /* ɤξν*/
    case 0 :
      x += w->separateWin.roman_width ;
      if( x >= width ){
	x = w->separateWin.roman_width ;
	num ++ ;
      }
      break ;
      /* ɤΰХܤν*/
    case 1 :
      x += w->separateWin.kanji_width ;
      if( x >= width ){
	x = w->separateWin.kanji_width ;
	num ++ ;
      }
      break ;
      /* ɤХܤν*/
    case 2 :
      break ;
      /* ʳΥɤʤ̵롣*/
    default :
      break ;
    }
    /* ֤򵭲롣*/
    if( pos == cur_pos )
      cur_num = num ;
  }

  /* ̤˥ȯƤʤ硣*/
  if( pos <= cur_pos ){
    if( ( x + w->separateWin.kanji_width ) > width )
      num ++ ;
    cur_num = num ;
  }

  /* ΰ֤֤Τʡ */
  if( cur_line != NULL )
    *cur_line = cur_num ;
  return num ;
}

/*
 * ʬɽԤؿ
 *----
 * ޤޤưʤǤɤƤϡ档
 */
static void skkinput_DiffDrawWindow
( Widget gw, struct SKKInputNode *node, char *text, char *ptext,
  int start_pos, int x, int y, int end_x, int end_y )
{
  SeparateWinWidget w = ( SeparateWinWidget )gw ;
  int pos, cx, cy, kx, ky ;
  char *sptr ;

  /* ξԤɽƤʬˤĤƺʬԤ*/
  sptr = skkinput_DiffDrawWindowSub1
    ( gw, node, text, ptext, start_pos, &x, &y, end_x, end_y,
      &cx, &cy, &pos ) ;

  /* ޤ̰դˤϽ񤤤ƤʤΤǡõȤĤäƤ뤫⤷ʤ*/
  if( y < end_y ){
    /* õԤ˸ߤΥΰ֤ФƤ*/
    kx = x ;
    ky = y ;
    while( *sptr != '\0' ){
      if( ( ( x + w->separateWin.kanji_width ) >= end_x &&
	    ( 0x80 & *sptr ) ) ||
	  ( x + w->separateWin.roman_width ) >= end_x ){
	skkwin_jerase
	  ( XtDisplay( gw ), XtWindow( gw ), w->separateWin.roman_ngc,
	    x, y, w->separateWin.kanji_width,
	    w->separateWin.font_height, w->separateWin.font_ascent ) ;
	x = 0 ;
	y += w->separateWin.font_height ;
      }
      if( y >= end_y )
	break ;
      skkwin_jerase
	( XtDisplay( gw ), XtWindow( gw ), w->separateWin.roman_ngc,
	  x, y, w->separateWin.roman_width,
	  w->separateWin.font_height, w->separateWin.font_ascent ) ;
      x += w->separateWin.roman_width ;
      sptr ++ ;
    }

    /* 뤬ɽƤ֤ޤãƤޤ... *
     * ˤϡõޤ*/
    if( y < node->prev_cy ||
	( x <= node->prev_cx && y == node->prev_cy ) ){
      skkwin_jerase
	( XtDisplay( gw ), XtWindow( gw ), w->separateWin.roman_ngc,
	  node->prev_cx, node->prev_cy, 
	  w->separateWin.kanji_width, w->separateWin.font_height,
	  w->separateWin.font_ascent ) ;
    }
    x = kx ;
    y = ky ;

    /* ޤ뤬ɽƤʤȤȤϡǸΰ֤ˤ *
     * Τʤ*/
    if( cy < 0 ){
      if( ( x + w->separateWin.roman_width ) > end_x ){
	x = 0 ;
	y += w->separateWin.font_height ;
      }
      if( node->cur_exist )
	skkinputDrawCursor
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	    w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	    x, y,
	    w->separateWin.roman_width,
	    w->separateWin.kanji_width,
	    w->separateWin.font_height, 
	    w->separateWin.font_ascent, False ) ;
      cx = x ; cy = y ;
    }
  }
  /* 󥫡ɽ֤򵭲Ƥ*/
  node->prev_cx = cx ; 
  node->prev_cy = cy ;
  /* ɽʸ򵭲Ƥ*/
  return ;
}

/*
 * ʬԤäƤʬΥᥤʬĤδؿ
 *---------------
 * ɽ줿ʸȺɽʤȤʤʸ򤸤äȸ٤
 * ɤʡ ʸƱɽʤǺѤ͡ ȤԤ
 * ä顢ѹϤ͡ Ȥġ
 */
static char *skkinput_DiffDrawWindowSub1
( Widget gw, struct SKKInputNode *node, char *text, char *ptext,
  int start_pos, int *retx, int *rety, int end_x, int end_y,
  int *rcx, int *rcy, int *retpos )
{
  SeparateWinWidget w = ( SeparateWinWidget )gw ;
  int x, y, pos, cx, cy, chara ;
  int charas_are_different, dkana_flag, skana_flag, diff_flag ;
  char *dptr, *sptr, *linetop ;

  /* ե饰ν*/
  diff_flag = skana_flag = dkana_flag = False ;

  /* ɽ֤ꡣ*/
  pos = start_pos ;
  x = *retx ;
  y = *rety ;
  chara = 0 ;
  cx = cy = -1 ;

  /* ʸꡣ*/
  linetop = sptr = ptext ;
  dptr = text ;

  /* ĤʸӤ롣*/
  while( *dptr != '\0' ){
    /* ɤɤɤʤ餽βХܤ*/
    if( 0x80 & *dptr ){
      dkana_flag = dkana_flag % 2 + 1 ;
    } else {
      dkana_flag = 0 ;
    }
    /* Ԥ뤫ɤȽꡣ*/
    switch( dkana_flag ){
      /* ɤν*/
    case 0 :
      /* Ԥޤ֤Υå*/
      if( ( x + w->separateWin.roman_width ) >= end_x ){
	/* 뤬ɽƤ顢äѤõ*/
	if( x == node->prev_cx && y == node->prev_cy )
	  skkwin_jerase
	    ( XtDisplay( gw ), XtWindow( gw ),
	      w->separateWin.roman_ngc,
	      x, y,
	      w->separateWin.kanji_width, w->separateWin.font_height,
	      w->separateWin.font_ascent ) ;
	/* ޤ֤򼨤 backslash ɽ롣*/
	skkwin_jputchar
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->separateWin.roman_ngc, w->separateWin.kanji_ngc, 
	    x, y, '\\', False ) ;
	x = 0 ;
	y += w->separateWin.font_height ;
	linetop = sptr = skkinput_WinGetNextLineTop
	  ( linetop, end_x, w->separateWin.roman_width,
	    w->separateWin.kanji_width ) ;
	/* ǲԤ뤳ȤϤʤΤǡǤ롣*/
	skana_flag = 0 ;
	/* ιԿĶƤޤäʤ顢ȴ롣*/
	if( y >= end_y )
	  goto exit_loop ;
      }
      break ;
      /* ɤΰХܤν*/
    case 1 :
      if( ( x + w->separateWin.kanji_width ) >= end_x ){
	/* 뤬ɽƤ顢äѤõ*/
	if( x >= node->prev_cx &&
	    ( node->prev_cx <= ( x + w->separateWin.kanji_width ) ) &&
	    y == node->prev_cy )
	  skkwin_jerase
	    ( XtDisplay( gw ), XtWindow( gw ),
	      w->separateWin.roman_ngc, x, y, 
	      w->separateWin.kanji_width, w->separateWin.font_height,
	      w->separateWin.font_ascent ) ;
	skkwin_jputchar
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->separateWin.roman_ngc, w->separateWin.kanji_ngc, 
	    x, y, '\\', False ) ;
	skkwin_jputchar
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->separateWin.roman_ngc, w->separateWin.kanji_ngc, 
	    x + w->separateWin.roman_width, y, '\\', False ) ;
#if 0
	skkwin_jerase
	  ( XtDisplay( gw ), XtWindiw( gw ), w->separateWin.roman_ngc,
	    x, y, w->separateWin.kanji_width,
	    w->separateWin.font_height, w->separateWin.font_ascent ) ;
#endif
	x = 0 ;
	y += w->separateWin.font_height ;
	/* ӤƤɽ줿ʸԤ줿֤õơ*
	 * إݥ󥿤ư롣*/
	linetop = sptr = skkinput_WinGetNextLineTop
	  ( linetop, end_x, w->separateWin.roman_width,
	    w->separateWin.kanji_width ) ;
	/* ǲԤ뤳ȤϤʤΤǡǤ롣*/
	skana_flag = 0 ;
	/* ιԿĶƤޤäʤ顢ȴ롣*/
	if( y >= end_y )
	  goto exit_loop ;
      }
      break ;
      /* ɤХܤν*/
    case 2 :
    default :
      break ;
    }
    /* ɽ줿ȽԤ*/
    if( 0x80 & *sptr ){
      skana_flag = skana_flag % 2 + 1 ;
    } else {
      skana_flag = 0 ;
    }
    /* ơ饯ϰۤʤΤǤ礦 */
    if( *sptr != *dptr || pos == node->cur_pos ||
	( x == node->prev_cx && y == node->prev_cy ) ||
	skana_flag != dkana_flag ){
      /* ࡣ֤ϥǥեȤǰۤʤΤʡ */
      charas_are_different = True ;
    } else {
      charas_are_different = False ;
    }
    switch( dkana_flag ){
      /* ɤν*/
    case 0 :
      /* ꤬˲ԤƤޤäƤˤ̾ɽ*/
      /* ǤϤʤơ饯Ӥưۤʤɽ*/
      if( charas_are_different ){
	if( pos == node->cur_pos ){
	  if( node->cur_exist ){
	    skkinputDrawCursor
	      ( XtDisplay( gw ), XtWindow( gw ), 
	        w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	        w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	        x, y,
	        w->separateWin.roman_width,
	        w->separateWin.kanji_width,
	        w->separateWin.font_height, 
	        w->separateWin.font_ascent,
	        False ) ;
	    if( w->separateWin.is_focus ){
	      skkwin_jputchar
		( XtDisplay( gw ), XtWindow( gw ),
		  w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
		  x, y, *dptr, True ) ;
	    } else {
	      skkwin_jputchar
		( XtDisplay( gw ), XtWindow( gw ), 
		  w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
		  x, y, *dptr, True ) ;
	    }
	  } else {
	    skkwin_jputchar2
	      ( XtDisplay( gw ), XtWindow( gw ), 
	        w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	        w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	        x, y, *dptr, 
	        w->separateWin.roman_width, w->separateWin.kanji_width,
	        w->separateWin.font_height, w->separateWin.font_ascent,
	        False ) ;
	  }
	  cx = x ; cy = y ;
	} else {
	  skkwin_jputchar2
	    ( XtDisplay( gw ), XtWindow( gw ), 
	      w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	      w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	      x, y, *dptr, 
	      w->separateWin.roman_width, w->separateWin.kanji_width,
	      w->separateWin.font_height, w->separateWin.font_ascent,
	      False ) ;
	}
      }
      /* ɽ֤ΰư*/
      x += w->separateWin.roman_width ;
      break ;
      /* ɤΰХܤν*/
    case 1 :
      chara = ( unsigned char )*dptr ;
      /* ä˲ԤƤޤäƤˤԤġ*/
      /* ɤΰХܤʸ󤬰ۤʤäƤ硣*/
      if( charas_are_different )
	diff_flag = True ;
      break ;
      /* ɤХܤν*/
    case 2 :
      chara = ( chara << 8 ) | ( ( unsigned char )*dptr ) ;
      /* ɤХܤʸ󤬰ۤʤäƤڤӡХ *
       * ܤǰۤʤäƤˤϽľκȤ롣                 */
      if( charas_are_different || diff_flag ){
	if( pos == ( node->cur_pos + 1 ) ){
	  if( node->cur_exist ){
	    skkinputDrawCursor
	      ( XtDisplay( gw ), XtWindow( gw ),
	        w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	        w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	        x, y,
	        w->separateWin.roman_width,
	        w->separateWin.kanji_width,
	        w->separateWin.font_height, 
	        w->separateWin.font_ascent,
	        True ) ;
	    /* 뤬ˤäƤ⡢եƤ */
	    /* ȿžɽˤɬפϤʤǤ礦 */
	    if( w->separateWin.is_focus ){
	      skkwin_jputchar
		( XtDisplay( gw ), XtWindow( gw ),
		  w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
		  x, y, chara, True ) ;
	    } else {
	      skkwin_jputchar
		( XtDisplay( gw ), XtWindow( gw ),
		  w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
		  x, y, chara, True ) ;
	    }
	  } else {
	    skkwin_jputchar2
	      ( XtDisplay( gw ), XtWindow( gw ), 
	        w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	        w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	        x, y, chara, 
	        w->separateWin.roman_width, w->separateWin.kanji_width,
	        w->separateWin.font_height, w->separateWin.font_ascent,
	        False ) ;
	  }
	  cx = x ; cy = y ;
	} else {
	  skkwin_jputchar2
	      ( XtDisplay( gw ), XtWindow( gw ), 
	        w->separateWin.roman_ngc, w->separateWin.kanji_ngc,
	        w->separateWin.roman_rgc, w->separateWin.kanji_rgc,
	        x, y, chara, 
	        w->separateWin.roman_width, w->separateWin.kanji_width,
	        w->separateWin.font_height, w->separateWin.font_ascent,
	        False ) ;
	}
	diff_flag = False ;
      }
      /* ɽ֤ΰư*/
      x += w->separateWin.kanji_width ;
      break ;
    default :
      dkana_flag = 0 ;
      break ;
    }
    dptr ++ ;
    if( *sptr != '\0' )
      sptr ++ ;
    pos  ++ ;
  }
exit_loop:
  /* ɽη̥뤬ޤǰưΤ֤*/
  *retx   = x ;
  *rety   = y ;
  *rcx    = cx ;
  *rcy    = cy ;
  *retpos = pos ;
  return sptr ;
}

/*
 * ʸ󡢥եȾ󡢲̤鼡ιƬؿ
 *---------------
 * ʸ󤫤ѿΥեȤΥեȤɽ륦
 * ɥβ򸫤ơޤǹԤвɽˤʤΤơι
 * Ƭˤʬ(ʸξ)ݥ󥿤Ȥ֤
 */
static char *skkinput_WinGetNextLineTop
( char *ptr, int win_width, int roman_width, int kana_width )
{
  int kana_flag = 0, x = 0 ;

  while( *ptr != '\0' ){
    if( 0x80 & *ptr ){
      kana_flag = kana_flag % 2 + 1 ;
    } else {
      kana_flag = 0 ;
    }
    switch( kana_flag ){
      /* ɤν*/
    case 0 :
      x += roman_width ;
      if( x >= win_width )
	return ptr ;
      break ;
      /* ɤΰХܤν*/
    case 1 :
      x += kana_width ;
      if( x >= win_width )
	return ptr ;
      break ;
      /* ɤХܤν*/
    case 2 :
    default :
      break ;
    }
    ptr ++ ;
  }
  return ptr ;
}

static int tmp()
{
#if 0
  xpos = 1 ; 
  ypos = 1 ;
  winwidth = 80 ;
  winheight = 3 ;
  /* ȥβϡ*/
  pr = XParseGeometry
    ( w->separateWin.geo_metry, &xpos, &ypos, &winwidth, &winheight ) ;
  /* ȥ꤫֤ȴФ*/
  if( ( pr & XValue ) && ( XNegative & pr ) ) {
    xpos += DisplayWidth
      ( display, DefaultScreen( display ) )
      - ( canvas_popup->core.border_width * 2 ) ;
  }
  if( ( pr & YValue ) && ( YNegative & pr ) ){
    ypos += DisplayHeight
      ( display, DefaultScreen( display ) )
      - ( canvas_popup->core.border_width * 2 ) ;
  }
  /* ĲʸޤɽΡ */
  cols = ( ( WidthValue & pr  ) && winwidth > 0 )? winwidth : 80 ;
  rows = ( ( HeightValue & pr ) && winheight > 0 )? winheight : 3 ;
  /* ɥΥꥵ¾ꡣ*/
  sizehints.base_width = canvas->core.border_width * 2 ;
  sizehints.base_height= canvas->core.border_width * 2 ;
  sizehints.width_inc  = w->separateWin.roman_width ;
  sizehints.height_inc = w->separateWin.font_height ;
  sizehints.min_width  = w->separateWin.roman_width * 2 ;
  sizehints.min_height = w->separateWin.font_height * 3 ;
  sizehints.flags      = ( PMinSize | PResizeInc ) ;

  /* ɥ礭λꡣ*/
  sizehints.width  = winwidth ;
  sizehints.height = winheight ;
  if( ( WidthValue & pr ) || ( HeightValue & pr ) ) {
    sizehints.flags |= USSize ;
  } else {
    sizehints.flags |= PSize ;
  }
  /* Window 礭롣*/
  winwidth  = canvas->core.border_width * 2 +
    cols * w->separateWin.roman_width ;
  winheight = canvas->core.border_width * 2 +
    rows * w->separateWin.font_height ;

  if( ( pr & XValue ) || ( pr & YValue ) ){
    sizehints.flags |= USSize | USPosition ;
    sizehints.flags |= PWinGravity ;
  }
  switch( pr & ( XNegative | YNegative ) ){
  case 0 :
    /*sizehints.win_gravity = NorthWestGravity ;*/
    sizehints.x = xpos ;
    sizehints.y = ypos ;
    break ;
  case XNegative :
    /*sizehints.win_gravity = NorthEastGravity ;*/
    sizehints.x = xpos - winwidth ;
    sizehints.y = ypos ;
    break ;
  case YNegative :
    /*sizehints.win_gravity = SouthWestGravity ;*/
    sizehints.x = xpos ;
    sizehints.y = ypos - winheight ;
    break ;
  default:
    /*sizehints.win_gravity = SouthEastGravity ;*/
    sizehints.x = xpos - winwidth ;
    sizehints.y = ypos - winheight ;
    break ;
  }
  /* Ƥ˥ꥵäƤ롩 */
  (void) XtMakeResizeRequest
    ( (Widget)canvas_popup,
      (Dimension)winwidth, (Dimension)winheight,
      &canvas_popup->core.width,
      &canvas_popup->core.height ) ;
  /* ֤ꤹ롣*/
  if( sizehints.flags & USPosition ){
    XtMoveWidget( canvas_popup, sizehints.x, sizehints.y ) ;
    sizehints.flags &= ~USPosition ;
  }
  /* Window Manager ˥ҥȤäƤ롣*/
  XSetWMNormalHints
    ( XtDisplay( gw ), canvas_popup->core.window, &sizehints ) ;
#endif
}

destroy()
{
  XDestroyWindowEvent *xdwe = ( XDestroyWindowEvent *)xevent ;
    
  rNode = skkinputs ;
  for( i = 0 ; i < MAX_SKKINPUTS ; i ++, rNode ++ ){
    /* Ƥʤ̵ͤ뤹롣*/
    if( !rNode->probe )
      continue ;
    /* ơɤ줫ҥåȤޤʡ */
    if( rNode->req_window == xdwe->window ){
      ignore_xerror() ;
      /* Ȥ褦ȤƤ뤫ϤϤͤ褦ˤ뤱ɡ */
      /* ̣Τɤʬʤ*/
      remove_allmyeventhandler
	( disp, rNode->req_window ) ;
      XSelectInput
	( disp, rNode->req_window, NoEventMask ) ;
      regard_xerror() ;
      rNode->req_window = rNode->focus_window = None ;
      /* 㤢Ĥޤ礦*/
      XtDestroyWidget( rNode->skkinput ) ;
    }
  }
}

tmp_key()
{
  if ((keysym == XK_Kanji)||
      ((keysym == XK_space)&&(event->state & ShiftMask))) {
    KI2_ConnectionOpen(w, l);
    return;
  }
}

tmp_font()
{
  /* skkinput ѤƤեȤλǤ */
  
  if( is_skkinputs_font( skkinputs_kanji_fonts, name ) &&
     !def_kanji_font ){
    /* ϿɤΥե饰 True ˤƤ*/
    def_kanji_font = True ;
    skkinput_fontset[ 1 ] = add_new_font( disp, name ) ;
    continue ;
  }
  /* skkinput ѤƤѻեȤλǤ */
  if( is_skkinputs_font( skkinputs_roman_fonts, name ) &&
     !def_roman_font ){
    /* ϿɤΥե饰 True ˤƤ*/
    def_roman_font = True ;
    skkinput_fontset[ 0 ] = add_new_font( disp, name ) ;
    continue ;
  }
}
