/* # skkinput (Simple Kana-Kanji Input)
 * skkkey.h --- define key tables.
 * This file is part of skkinput.
 * Copyright (C) 1997
 * Takashi SAKAMOTO (sakamoto@yajima.kuis.kyoto-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef SKKKEY_H
#define SKKKEY_H

/*
 * ǽΰʬ긺äꤹ뤫⤷ޤ
 * ä skk Ƥޤ
 */
enum {
  FUNCNO_SELF_INSERT_CHARACTER = 0,
  FUNCNO_J_SELF_INSERT,
  FUNCNO_J_SELF_ZENKAKU_INSERT, 
  FUNCNO_J_DISPLAY_CODE_FOR_CHAR_AT_POINT,
  FUNCNO_J_SET_HENKAN_POINT,
  FUNCNO_J_SET_HENKAN_POINT_SUBR,
  FUNCNO_J_INSERT_A,
  FUNCNO_J_INSERT_E,
  FUNCNO_J_INSERT_I,
  FUNCNO_J_INSERT_O,
  FUNCNO_J_INSERT_U,
  FUNCNO_J_KANA_INPUT,
  FUNCNO_J_START_HENKAN,
  FUNCNO_J_INSERT_COMMA,
  FUNCNO_J_INSERT_PERIOD,
  FUNCNO_J_PURGE_FROM_JISYO,
  FUNCNO_J_INPUT_BY_CODE_OR_MENU,
  FUNCNO_J_MODE_OFF,
  FUNCNO_J_TOGGLE_KANA,
  FUNCNO_J_PREVIOUS_CANDIDATE,
  FUNCNO_J_KAKUTEI,
  FUNCNO_J_ABBREV_INPUT,
  FUNCNO_J_ABBREV_PERIOD,
  FUNCNO_J_ABBREV_COMMA,
  FUNCNO_J_ZENKAKU_EIJI,
  FUNCNO_J_ZENKAKU_HENKAN,
  FUNCNO_J_TODAY,
  FUNCNO_SAVE_SKKINPUT_LOCAL_JISYO,
  FUNCNO_J_MODE_OFF_AND_SELF_INSERT,

  FUNCNO_J_KANAINPUT_MODE_ON,
  FUNCNO_J_NEWLINE,
  FUNCNO_J_SET_MARK_COMMAND,
  FUNCNO_J_FORWARD_CHAR,
  FUNCNO_J_BACKWARD_CHAR,
  FUNCNO_J_DELETE_CHAR,
  FUNCNO_J_DELETE_BACKWARD_CHAR,
  FUNCNO_J_TRY_COMPLETION,
  FUNCNO_J_END_OF_LINE,
  FUNCNO_J_BEGINNING_OF_LINE,
  FUNCNO_J_KILL_LINE,
  FUNCNO_J_YANK,
  FUNCNO_J_KILL_REGION,
  FUNCNO_J_KILL_RING_SAVE,
  FUNCNO_J_EXCHANGE_POINT_AND_MARK,
  FUNCNO_J_PREVIOUS_LINE,
  FUNCNO_J_NEXT_LINE,
  FUNCNO_J_TRANSPOSE_CHARS,
  FUNCNO_J_REDRAW,
  FUNCNO_J_PREFIX_CHAR,
  FUNCNO_J_SENDBACK_KEY,
  FUNCNO_J_KEYBOARD_QUIT,
  FUNCNO_CLOSE_SKKINPUT,
  FUNCNO_VC_TOGGLE_CHATMODE,
  FUNCNO_NOT_MODIFIED,
  FUNCNO_J_FORWARD_WORD,
  FUNCNO_J_BACKWARD_WORD,
  FUNCNO_J_UPCASE_WORD,
  FUNCNO_J_DOWNCASE_WORD,
  FUNCNO_J_CAPITALIZE_WORD,
  FUNCNO_VC_TOGGLE_EGGNL,
  FUNCNO_INVALID_CHAR,
} ;


/*
 * ʸϤλ(ʸǽ)бɽΥɽ빽¤Ρ
 */
struct skkinputTwoKeys {
  unsigned char *chara ;
  int  function_no ;
} ;

#endif
